<template>
  <v-form @submit.prevent="onSubmit">
    <v-container>
      <v-row>
        <v-col
          cols="12"
          md="4"
        >
          <first-name-field
            v-model="$v.form.firstName.$model"
            :error-messages="firstNameValidations"
            :disabled="isLoading"
            required-flag
          />
        </v-col>

        <v-col
          cols="12"
          md="4"
        >
          <last-name-field
            v-model="$v.form.lastName.$model"
            :error-messages="lastNameValidations"
            :disabled="isLoading"
            required-flag
          />
        </v-col>

        <v-col
          cols="12"
          md="4"
        >
          <email-not-editable-field :email="$v.form.email.$model" />
        </v-col>

        <v-col
          cols="12"
          class="text-right"
        >
          <update-btn
            type="submit"
            :loading="isLoading"
          >
            {{ $t('update') }}
          </update-btn>
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script>
  import { get } from 'vuex-pathify'
  import { validationMixin } from 'vuelidate'
  import { maxLength, required } from 'vuelidate/lib/validators'
  import UpdateBtn from './UpdateBtn'

  const formInitialState = {
    firstName: '',
    lastName: '',
    email: '',
  }

  export default {
    name: 'PersonalInformation',
    components: {
      UpdateBtn,
    },
    mixins: [validationMixin],
    data () {
      return {
        isLoading: false,
        form: formInitialState,
      }
    },
    validations: {
      form: {
        firstName: {
          required,
          maxLength: maxLength(32),
        },
        lastName: {
          required,
          maxLength: maxLength(64),
        },
        email: {},
      },
    },
    computed: {
      administrator: get('auth/authUser'),
      firstNameValidations () {
        const firstName = this.$v.form.firstName
        if (!firstName.$dirty) {
          return ''
        }
        return !firstName.required
          ? this.$t('global.validations.required')
          : !firstName.maxLength
            ? this.$t('global.validations.maxLength', { n: firstName.$params.maxLength.max })
            : ''
      },
      lastNameValidations () {
        const lastName = this.$v.form.lastName
        if (!lastName.$dirty) {
          return ''
        }
        return !lastName.required
          ? this.$t('global.validations.required')
          : !lastName.maxLength
            ? this.$t('global.validations.maxLength', { n: lastName.$params.maxLength.max })
            : ''
      },
    },
    created () {
      const { firstName, lastName, email } = this.administrator
      this.form = { ...this.form, firstName, lastName, email }
    },
    methods: {
      onSubmit () {
        const form = this.$v.form
        form.$touch()
        if (!form.$anyError) {
          this.isLoading = true
          this.$store.dispatch('auth/updateAuthUserFullName', { ...this.form })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          update: 'Atualizar',
          updateSuccess: 'Informações pessoais atualizadas com sucesso!',
          updateError: 'Ops... Ocorreu um erro ao tentar atualizar suas informações pessoais. Por favor, tente novamente.',
        },
        'en-US': {
          update: 'Update',
          updateSuccess: 'Personal information updated successfully!',
          updateError: 'Oops... An error occurred while trying to update your personal information. Please try again.',
        },
      },
    },
  }
</script>
